import { type DisclosureGroupProps } from 'react-stately';
interface Props {
    groups: TDisclosureGroup[];
    icon?: React.ReactNode;
    /** State key to use with a store */
    selectStateKey?: string;
    /** Icon to display for the select */
    selectIcon?: React.ReactNode;
}
type TDisclosureGroup = {
    key: string;
    label: string | React.ReactNode;
    tabs?: {
        key: string;
        label: string | React.ReactNode;
        body?: React.ReactNode;
    }[];
};
/**
 * Display an interactive OpenAPI disclosure group.
 */
export declare function OpenAPIDisclosureGroup(props: DisclosureGroupProps & Props): import("react").JSX.Element;
export {};
