import { t } from './translate';
/**
 * Display the stability of an OpenAPI operation.
 */
export function OpenAPIOperationStability(props) {
    var stability = props.stability, context = props.context;
    var stabilityLabel = getStabilityLabel(stability, context);
    if (!stabilityLabel) {
        return null;
    }
    return (<div className={"openapi-stability openapi-stability-".concat(stability)}>{stabilityLabel}</div>);
}
/**
 * Get the stability label for the given stability level.
 */
function getStabilityLabel(stability, context) {
    switch (stability) {
        case 'experimental':
            return t(context.translation, 'stability_experimental');
        case 'alpha':
            return t(context.translation, 'stability_alpha');
        case 'beta':
            return t(context.translation, 'stability_beta');
        default:
            return null;
    }
}
