import { type Key, type ListBoxItemProps, type PopoverProps, type SelectProps } from 'react-aria-components';
export type OpenAPISelectItem = {
    key: Key;
    label: string | React.ReactNode;
};
interface OpenAPISelectProps<T extends OpenAPISelectItem> extends Omit<SelectProps<T>, 'children'> {
    items: T[];
    children: React.ReactNode | ((item: T) => React.ReactNode);
    placement?: PopoverProps['placement'];
    stateKey?: string;
    /**
     * Icon to display in the select button.
     */
    icon?: React.ReactNode;
}
export declare function useSelectState(stateKey?: string, initialKey?: Key): {
    key: (string | number) | null;
    setKey: (key: Key | null) => void;
};
export declare function OpenAPISelect<T extends OpenAPISelectItem>(props: OpenAPISelectProps<T>): import("react").JSX.Element;
export declare function OpenAPISelectItem(props: ListBoxItemProps): import("react").JSX.Element;
export {};
