import { fromJSON, toJSON } from 'flatted';
import type { Filesystem, OpenAPIV3xDocument } from '@gitbook/openapi-parser';
import type { OpenAPIWebhookData } from './types';
export { fromJSON, toJSON };
/**
 * Resolve an OpenAPI webhook in a file and compile it to a more usable format.
 */
export declare function resolveOpenAPIWebhook(filesystem: Filesystem<OpenAPIV3xDocument>, webhookDescriptor: {
    name: string;
    method: string;
}): Promise<OpenAPIWebhookData | null>;
