import type { OpenAPIV3 } from '@gitbook/openapi-parser';
import type { OpenAPIContext } from '../context';
/**
 * Generate an example from a reference object.
 */
export declare function getExampleFromReference(ref: OpenAPIV3.ReferenceObject, context: OpenAPIContext): OpenAPIV3.ExampleObject;
/**
 * Get examples from a media type object.
 */
export declare function getExamplesFromMediaTypeObject(args: {
    mediaType: string;
    mediaTypeObject: OpenAPIV3.MediaTypeObject;
    context: OpenAPIContext;
}): {
    key: string;
    example: OpenAPIV3.ExampleObject;
}[];
/**
 * Get example from a schema object.
 */
export declare function getExampleFromSchema(args: {
    schema: OpenAPIV3.SchemaObject;
}): OpenAPIV3.ExampleObject;
/**
 * Get the examples from a media type object.
 */
export declare function getExamples(props: {
    mediaTypeObject: OpenAPIV3.MediaTypeObject;
    mediaType: string;
    context: OpenAPIContext;
}): {
    key: string;
    label: string;
    body: import("react").JSX.Element;
}[];
